/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CategoriaRutaExcecaoDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaCtrl;
import com.rjconsultores.ventaboletos.entidad.CategoriaRutaExcecao;
import com.rjconsultores.ventaboletos.service.CategoriaRutaExcecaoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author Wallace
 */
@Service("categoriaRutaExcecaoService")
public class CategoriaRutaExcecaoServiceImpl implements CategoriaRutaExcecaoService {

    @Autowired
    private CategoriaRutaExcecaoDAO categoriaRutaExcecaoDAO;

    public List<CategoriaRutaExcecao> obtenerTodos() {
        return categoriaRutaExcecaoDAO.obtenerTodos();
    }

    public CategoriaRutaExcecao obtenerID(Integer id) {
        return categoriaRutaExcecaoDAO.obtenerID(id);
    }

    @Transactional
    public CategoriaRutaExcecao suscribir(CategoriaRutaExcecao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaRutaExcecaoDAO.suscribir(entidad);
    }

    @Transactional
    public CategoriaRutaExcecao actualizacion(CategoriaRutaExcecao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaRutaExcecaoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(CategoriaRutaExcecao entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        categoriaRutaExcecaoDAO.actualizacion(entidad);
    }

    public CategoriaRutaExcecao busquedaPoCategoriaCtrl(CategoriaCtrl categoriaCtrl) {
        return categoriaRutaExcecaoDAO.busquedaPorCategoriaCtrl(categoriaCtrl);
    }
    
    @Override
	@Transactional
	public void actualizacionAuditagem(List<CategoriaRutaExcecao> lsCategoriaRutaExcecao) {
		for (CategoriaRutaExcecao cc : lsCategoriaRutaExcecao) {
			if(Boolean.TRUE.equals(cc.getActivo())) {
				continue;
			}
			categoriaRutaExcecaoDAO.actualizacion(cc);
		}		
	}
}
